#define MaximumBlockDataSize 90

get_message(char *BlockPtr,int MaxSize,int timeout_parameter)
{
	int LastMessageNumber;			// unnused variable, for compatibility with the new message functions

	int Size;
	int BlockSize;
	int BlockNumber;
	int ReadBlockIncrNumber;
	int BlockAux;
	int PositionId;
	int ExpectedBlockNumber;
	int Aux2;
	int n;
	int ConfirmationRetry;
	int PtrPosition;
	char RetransmitBuffer[256];
	int SizeOfMessage;
	int SizeOfMessageData;
	int BlockNotOk;
	int SizeOfAuxData;
	int SizeOfMessageAnswer=16;
	int timeout,initial_timeout,timeoutpart;

#IF compile_get_message_debug_info 1;
	int confirmation_counter;
	int block_count;
	int bad_count;
#ENDIF ;

#IF RadioFunctions 1 ;
	int errortime;
	set_server_status_line('<',work_base_id);
#ENDIF ;

#IF compile_debug_number 1;
	debug_number(2000);
#ENDIF;

	BlockAux=Message_ANSWER;
	SizeOfAuxData=14;
#IF system_type horizontal rio ;
	set_lcd_light_power(-1);
#ENDIF ;

	initial_timeout=timeout_parameter&2147483647;
	if(initial_timeout<2048)
	{
		initial_timeout=2048;
	}

ini_get_message:
	ConfirmationRetry=1;
	do
	{
		message_channel_receive
		do
		{
			do
			{
									// after wait_message_block, REG2 has the remaining TIMEOUT value
				*destination_id=0;
// debug_info("Wait message block");

				timeout=initial_timeout;
#IF RadioFunctions 1 ;
				errortime=0;
#ENDIF ;
				while(timeout)
				{
#IF RadioFunctions 1 ;
					if(AutoFindBase)
					{
						if(errortime>=(ONESECOND*10))
						{
							if(change_radio_base())
							{
								set_server_status_line('O',work_base_id);
							}
							strcpy(work_base_id+6," X");		// define caminho
							test_radio_base(work_base_id,3,0);	//
							errortime=ONESECOND*5;		// mas nao ha a certeza de que conseguiu
							strcpy(work_base_id+6," P");
							message_channel_receive
						}
					}
#ENDIF ;
					timeoutpart=timeout;
					if(timeoutpart>ONESECOND*5)
					{
						timeoutpart=ONESECOND*5;
					}
#IF debug_beeps 1 ;
	beep(4,400);
#ENDIF ;

#IFNOT RadioFunctions 1 ;
					message_channel_off			// ??? nao tenho a certeza
					message_channel_receive			//       de que isto e preciso
#ENDIF;					

					if(SizeOfMessage=wait_message_block(timeoutpart))
					{
					
#IF debug_beeps 1 ;
	beep(32,50);
#ENDIF ;
#IF compile_get_message_debug_info 1;
	block_count++;
#ENDIF ;

#IF RadioFunctions 1 ;
						errortime=0;

						if(status_func_set_server_status_line!='<')
						{
							set_server_status_line('<',work_base_id);
						}
#ENDIF ;
						break;
					}
					
#IF debug_beeps 1 ;
	beep(2,1600);
#ENDIF ;
#IF RadioFunctions 1 ;
					errortime+=timeoutpart;
#ENDIF ;
					timeout-=timeoutpart;
#IF compile_get_message_debug_info 1;
	bad_count++;
	show_radio_debug_info();
#ENDIF ;
				}

				if(!SizeOfMessage)
				{
					message_channel_off
					*ExpectedBlockId=0;
#IF RadioFunctions 1 ;
					set_server_status_line(0,0);
#ENDIF;

#IF compile_debug_number 1;
	debug_number(2030);
#ENDIF;
					return(0);
				}
				
				BlockSize=0;										// Read Block ID
				read_message_block(remote_id,8);
				read_message_block(&BlockNumber,2);
				read_message_block(&ReadBlockIncrNumber,2);
				read_message_block(&BlockSize,2);
				
				if(BlockSize >=65530)								// Blocos Grandes
				{
					read_message_block(&BlockSize,4);
					SizeOfAuxData=18;
				}
					
//debug_info("Block Number...",BlockNumber);
				
			}
			while(BlockNumber==Message_ANSWER );						// Ignora Confirmaes
//debug_info("After all ",1);

			if(BlockSize>MaxSize)
			{
// debug_info("After all Error ",1);
#IF RadioFunctions 1 ;
				set_server_status_line(0,0);
#ENDIF;

#IF compile_debug_number 1;
	debug_number(2040);	
#ENDIF;
				return(-1);
			}

			BlockNotOk=1;
			if(BlockNumber==Message_RESET)							// Reset
			{
				if(reset_function)
				{
					reset_function();
				}
				if(!memcmp(ExpectedBlockId,remote_id,8) || *ExpectedBlockId==0)
				{
					BlockNotOk=0;
					ExpectedBlockNumber=0;

#IFNOT only_one_active_connection 1 ;
					for(PositionId=0;PositionId<MessageIdCount;PositionId++)
					{
						if(!memcmp(MessageBlockId[PositionId],remote_id,8))		// Terminal Conhecido ??
						{										// Se SIM
							ExpectedBlockNumber=1;
							MessageReceiveBlockNumber[PositionId]=1;
							MessageTransmitBlockNumber[PositionId]=1;
							MessageTemporaryBlockNumber[PositionId]=1;
							break;
						}
					}
#ENDIF ;

#IF only_one_active_connection 1 ;
					MessageIdCount=0;
#ENDIF

					if(ExpectedBlockNumber==0)
					{											// Se Desconhecido...
						ExpectedBlockNumber=1;
						MessageReceiveBlockNumber[MessageIdCount]=1;
						MessageTransmitBlockNumber[MessageIdCount]=1;
						MessageTemporaryBlockNumber[MessageIdCount]=1;
						memcpy(MessageBlockId[MessageIdCount],remote_id,9);
						PositionId=MessageIdCount;
						MessageIdCount++;
						if(MessageIdCount>number_of_devices-2)
						{
							cls();
							print_string("Error Device Number");
							getch();
						}						
					}
					*ExpectedBlockId=0;
					if(MessageReceiveSequencialNumber[PositionId]!=ReadBlockIncrNumber)
					{
						MessageReceiveSequencialNumber[PositionId]=ReadBlockIncrNumber-1;
					}	
				}
			}

			if(*ExpectedBlockId==0)
			{
#IFNOT only_one_active_connection 1 ;
				for(PositionId=0;PositionId<MessageIdCount;PositionId++)		// Inicio de um Bloco de Dados
				{
					if(!memcmp(MessageBlockId[PositionId],remote_id,8))
					{
#ENDIF ;
						memcpy(ExpectedBlockId,remote_id,9);
						ExpectedBlockNumber=MessageReceiveBlockNumber[PositionId];
						goto Label3;
#IFNOT only_one_active_connection 1 ;
					}
				}
#ENDIF;
				message_channel_off

// debug_info("After all Error ",2);		
#IF RadioFunctions 1 ;		
				set_server_status_line(0,0);
#ENDIF;
#IF compile_debug_number 1;
	debug_number(2050);
#ENDIF;
				return(0);
Label3:
			}
			
			if((MessageReceiveSequencialNumber[PositionId]-ReadBlockIncrNumber)>65000)
			{
				MessageReceiveSequencialNumber[PositionId]=ReadBlockIncrNumber-1;
			}

#IF compile_get_message_debug_info 1;
	show_radio_debug_info();
#ENDIF ;

		}
//		while( memcmp(ExpectedBlockId,remote_id,8) || MessageReceiveSequencialNumber[PositionId]>=ReadBlockIncrNumber);
		while(MessageReceiveSequencialNumber[PositionId]>=ReadBlockIncrNumber);

		MessageReceiveSequencialNumber[PositionId]=ReadBlockIncrNumber;
		
		SizeOfMessageData=SizeOfMessage-SizeOfAuxData;

		if(ExpectedBlockNumber == BlockNumber)
		{
			BlockNotOk=0;
			PtrPosition=(BlockNumber-MessageReceiveBlockNumber[PositionId])*SizeOfMessageData;
			if(BlockSize>SizeOfMessageData) 
			{
				Size=SizeOfMessageData;
			}
			else
			{
				Size=BlockSize;
				ConfirmationRetry=1;
			}

			if ((PtrPosition+Size)>MaxSize)
			{
				goto ini_get_message;
			}
			
			if(Size)
			{				
				read_message_block(BlockPtr+PtrPosition,Size);
			}			
			ExpectedBlockNumber++;
														// foi recebido um bloco valido,
			// MessageReceiveBlockNumber[PositionId]=ExpectedBlockNumber;		// ??? agora so queremos blocos a partir deste

			if(initial_timeout<HALFASECOND)
			{
				initial_timeout=HALFASECOND;
			}
		}
		else
		{
			delay(50000);									// Tempo para a antena ficar em recepo
		}
	
		message_channel_send
		for(n=1;n<=ConfirmationRetry;n++)
		{
#IF compile_get_message_debug_info 1;
	confirmation_counter++;
	show_radio_debug_info();
#ENDIF ;
			BlockIncrNumber++;
			write_message_header
			write_message_block_cc(remote_id,8			wmb_sufix
			write_message_block(&SizeOfMessageAnswer,1	wmb_sufix
			write_message_block(terminal_id,8			wmb_sufix
			write_message_block(&BlockAux,2			wmb_sufix
			write_message_block(&BlockIncrNumber,2		wmb_sufix
			write_message_block(&ExpectedBlockNumber,4	wmb_sufix
			write_message_checksum
		}
		message_channel_delay_after_send
		message_channel_off
		correct_16c71_reset();
		beep_if_serial
	}
	while(BlockSize>SizeOfMessageData || BlockNotOk);
	*ExpectedBlockId=0;
	MessageReceiveBlockNumber[PositionId]=ExpectedBlockNumber;	

	if(!BlockNumber)
	{
		goto ini_get_message;

// debug_info("After all Error ",4);
#IF RadioFunctions 1 ;		
		set_server_status_line(0,0);
#ENDIF;
#IF compile_debug_number 1;
	debug_number(2070);
#ENDIF;
		return(0);
	}

// debug_info("After all OK ",1);
#IF RadioFunctions 1 ;	
	set_server_status_line(0,0);
#ENDIF;

#IF compile_debug_number 1;
	debug_number(2080);
#ENDIF;
	return(PtrPosition+Size);
}

//
// --------------------------------------------------------------
//

#IF RadioFunctions 1 ;
send_radio_message2(char *BlockPtr,char *destination_id,int MessageSize,int times)
#ELSE ;
send_message(char *BlockPtr,char *destination_id,int MessageSize,int times)
#ENDIF ;
{
	int n;
	int BlockNumber;
	int MessageSizeLeft;
	int MessageSizeLeftAux=65535;									// Blocos > 64K
	int Aux1;
	int Aux2;
	int PositionId;
	char SizeOfMessage;
	int SizeOfMessageBlock;
	int SIZE_OF_MESSAGE_BLOCK;
	int ShowProgress;	

	SIZE_OF_MESSAGE_BLOCK=MaxSizeOfMessageBlock;

#IF compile_debug_number 1;
debug_number(340);
#ENDIF ;	



#IFNOT only_one_active_connection 1 ;
	for(PositionId=0;PositionId<MessageIdCount;PositionId++)			// Inicio de um Bloco de Dados
	{
		if(!memcmp(MessageBlockId[PositionId],destination_id,8))
		{
#ENDIF;		
			BlockNumber=MessageTemporaryBlockNumber[PositionId];
			goto Label1;
#IFNOT only_one_active_connection 1 ;
		}
	}
#ENDIF;
	return(0);
Label1:

#IF compile_debug_number 1;
debug_number(341);
#ENDIF ;	

#IF system_type horizontal rio ;
	set_lcd_light_power(-1);
#ENDIF ;

	if(MessageSize<65530)
	{
		SIZE_OF_MESSAGE_BLOCK+=4;
	}

	if(MessageSize<SIZE_OF_MESSAGE_BLOCK)
	{
		SizeOfMessageBlock = MessageSize;
	}
	else
	{
		SizeOfMessageBlock = SIZE_OF_MESSAGE_BLOCK;
	}

	if(MessageSize<65530)
	{
		SizeOfMessage=SizeOfMessageBlock+14;
	}
	else
	{
		SizeOfMessage=SizeOfMessageBlock+18;
	}
	
//	Aux1=0;
	Aux1=(BlockNumber-MessageTransmitBlockNumber[PositionId])*SizeOfMessageBlock;

#IF compile_debug_number 1;
debug_number(342);
#ENDIF ;	

	if(ShowProgress=(MessageSize>512))
	{

#IF compile_debug_number 1;
debug_number(343);
#ENDIF ;	


		cursor_width(0);
		set_display(0);
#IFNOT system_type ponto ;
		set_function_keys("",1);		
#ENDIF ;
	}

#IF compile_debug_number 1;
debug_number(350);
#ENDIF ;	

	wait_channel_free
	do
	{
	
#IF compile_debug_number 1;
debug_number(351);
#ENDIF ;	
		MessageSizeLeft=MessageSize-Aux1;
		n=0;
		do
		{

#IF compile_debug_number 1;
debug_number(352);
#ENDIF ;	

		
// cursor(0); print_string("BAD         ");
			if( n >= times && times != -1 )
			{

// cursor(0); print_string("Exit        ");
				MessageTemporaryBlockNumber[PositionId]=BlockNumber;
				return(0);
			}
#IFNOT system_type ponto ;
#IF compile_os_menu 1 ;

			if(ShowProgress)
			{
				cursor(display_width*7);
//				setch(1);
				Aux2=MessageSize-MessageSizeLeft+SizeOfMessageBlock;
				bar2(&Aux2,MessageSize,16,0);print_string(" ");print_number((Aux2*100)/MessageSize);print_char('%');
				update_screen();
			}
#ENDIF ;
#ENDIF ;
			if(n)
			{
// cursor(0); print_string("Delay       ");
//				sensech();
				correct_16c71_reset();
				wait_channel_free
			}
// cursor(0); print_string("Send        ");

#IF debug_beeps 1 ;
		itoa(SizeOfMessage&1,temp_string,10);
		write_cpu_register32(CPU_SCREENLINE2,temp_string);
		really_update_screen();
#ENDIF ;

			BlockIncrNumber++;
			message_channel_send
			write_message_header
			write_message_block_cc(destination_id,8	wmb_sufix
			write_message_block(&SizeOfMessage,1	wmb_sufix
			write_message_block(terminal_id,8		wmb_sufix
			write_message_block(&BlockNumber,2		wmb_sufix
			write_message_block(&BlockIncrNumber,2	wmb_sufix
			if(MessageSize<65530)
			{
				write_message_block(&MessageSizeLeft,2	wmb_sufix
			}
			else
			{
				write_message_block(&MessageSizeLeftAux,2	wmb_sufix
				write_message_block(&MessageSizeLeft,4	wmb_sufix
			}				
			write_message_block(BlockPtr+Aux1,SizeOfMessageBlock wmb_sufix
			write_message_checksum
			message_channel_delay_after_send
			message_channel_off
			n++;
// cursor(0); print_string("Confirm     ");
		} while( get_message_confirmation(destination_id,&BlockNumber) == -1 );
// cursor(0); print_string("OK          ");

#IF compile_debug_number 1 ;
debug_number(353);
#ENDIF ;	

	}while(MessageSize>(Aux1=(BlockNumber-MessageTransmitBlockNumber[PositionId])*SizeOfMessageBlock));
	
#IF compile_debug_number 1 ;
debug_number(354);
#ENDIF ;	

	
	MessageTransmitBlockNumber[PositionId]=BlockNumber;
	MessageTemporaryBlockNumber[PositionId]=BlockNumber;
	return(1);
}

//

// --------------------------------------------------------------
//

write_message_full_block(char *BlockPtr,int MessageSize, char *destination_id,char *local_id )
{
	int Aux2;
	MessageSize+=8;
	message_channel_send
	write_message_header
	write_message_block_cc(destination_id,8	wmb_sufix
	write_message_block(&MessageSize,1		wmb_sufix
	write_message_block(local_id,8			wmb_sufix
	write_message_block(BlockPtr,MessageSize-8 	wmb_sufix
	write_message_checksum
	message_channel_delay_after_send
	message_channel_off
}

//
// --------------------------------------------------------------
//

#IF RadioFunctions 1 ;
reset_radio_message2(char *destination_id,char *reset__message)
#ELSE ;
reset_message(char *destination_id,char *reset__message,int times)
#ENDIF ;
{ 
	int PositionId;
	char temp[14];

	//*ExpectedBlockId=0;

#IFNOT radio_type none ;
	if(read_cpu_register(CPU_STARTUP_CODE)!=1)
	{
		set_radio_khz(40000);	
	}
#ENDIF;	

#IFNOT only_one_active_connection 1 ;
	for(PositionId=0;PositionId<MessageIdCount;PositionId++)
	{
		if(!memcmp(MessageBlockId[PositionId],destination_id,8))
		{
#ENDIF;		
			MessageTransmitBlockNumber[PositionId]=0;
			MessageTemporaryBlockNumber[PositionId]=0;
			MessageReceiveBlockNumber[PositionId]=1;
			MessageReceiveSequencialNumber[PositionId]=0;

			memcpy(temp,reset__message,10);
			memcpy(temp+10,&program_checksum,4);
		
			if(send_message(temp,destination_id,14,1)) 
			{
				return(1);
			}

			return(0);
#IFNOT only_one_active_connection 1 ;			
		}
	}
#ENDIF;

#IF only_one_active_connection 1 ;
	MessageIdCount=0;
#ENDIF;

	MessageTransmitBlockNumber[MessageIdCount]=0;
	MessageTemporaryBlockNumber[MessageIdCount]=0;
	MessageReceiveBlockNumber[MessageIdCount]=1;
	MessageReceiveSequencialNumber[MessageIdCount]=0;
	memcpy(MessageBlockId[MessageIdCount],destination_id,9);
	MessageIdCount++;
	if(MessageIdCount>number_of_devices-2)
	{
		cls();
		print_string("Error Device Number");
		getch();
	}

	memcpy(temp,reset__message,10);
	memcpy(temp+10,&program_checksum,4);

	if(send_message(temp,destination_id,14,1)) 
	{
		return(1);
	}

	MessageIdCount--;
	return(0);
}

#IF RadioFunctions 1 ;
pressanykey()
{
	int ctsleep;
#IFNOT software_type RADIOBASE ;
	int n,m;

	ctsleep++;
	if(ctsleep<50)
	{
		return;
	}
	ctsleep=0;
	for(m=1;m<3;m++)
	{
		for(n=30;n<100;n++)
		{
			beep(30,n);
		}
	}
	flush_keyboard_buffer();

	if(!hardware_is_pricechecker)				// PriceChecker
	{
		getch();	
	}
#ENDIF ;
}

public int reset_radio_message(char *work_base_id,char *resetmessage,int times)
{
	int RadioResetFailureCounter;

	ctsleep_func_pressanykey=0;
	RadioResetFailureCounter=0;
	set_server_status_line('>',work_base_id);

	set_radio_channel(work_base_id);	// muda em definitivo para o canal da base (registo nordic_configuration)
	memcpy(work_base_id+6," P",2);

	while(reset_radio_message2(work_base_id,resetmessage)==0)
	{
		RadioResetFailureCounter++;
		//if(RadioResetFailureCounter==5 || RadioResetFailureCounter==6)
		//{
		//	change_radio_khz();
		//}	

		if(RadioResetFailureCounter==7)
		{
			RadioResetFailureCounter=0;
		}	
		change_radio_base();
		pressanykey();
	}
	
	return(1);
}

public int send_radio_message(char *BlockPtr,char *destination_id,int BlockSize,int timeout)
{
	timeout=timeout&2147483647;
	ctsleep_func_pressanykey=0;

#IF compile_debug_number 1;
debug_number(330);
#ENDIF ;	
	while(timeout>0)
	{
#IF debug_beeps 1 ;
		write_cpu_register32(CPU_SCREENLINE1,destination_id);
		really_update_screen();
#ENDIF ;	
#IF compile_debug_number 1;
debug_number(331);
#ENDIF ;	
		set_server_status_line('>',work_base_id);
#IF compile_debug_number 1;
debug_number(331);
#ENDIF ;	
		if(send_radio_message2(BlockPtr,destination_id,BlockSize,3))
		{
			set_server_status_line(0,0);
#IF compile_debug_number 1;
debug_number(332);
#ENDIF ;	
			return(1);
		}
		change_radio_base();
		timeout-=confirmations_timeout;
	}
	set_server_status_line(0,0);
#IF compile_debug_number 1;
debug_number(333);
#ENDIF ;	
	return(0);
}
#ENDIF ;

get_message_confirmation(char *destination_id,int *BlockNumber)
{
int  BlockAux;
int  ReadBlockIncrNumber;
int  ExpectedBlockNumber;
int  PositionId;	
int Aux2;
int size;
int SizeOfMessageAnswer=16;

label1:	
	message_channel_receive
	write_cpu_register(CPU_RADIO_SYNC_READ_SIZE,8);
	BlockAux=0;
	ReadBlockIncrNumber=0;

// write_cpu_register(184,0);

	size=wait_message_block(confirmations_timeout);
// debug_info("After confirmation",0);	

	message_channel_off
	
	if(size)
	{

		read_message_block(remote_id,8);
		read_message_block(&BlockAux,2);
		
		if(BlockAux==Message_ANSWER && !memcmp(destination_id,remote_id,8) && size>10)
		{
			read_message_block(&ReadBlockIncrNumber,2);
			read_message_block(&ExpectedBlockNumber,4);
			*BlockNumber=ExpectedBlockNumber;

#IFNOT only_one_active_connection 1 ;
			
														// Testa Blocos Repetidos
			for(PositionId=0;PositionId<MessageIdCount;PositionId++)			// Inicio de um Bloco de Dados
			{
				if(!memcmp(MessageBlockId[PositionId],remote_id,8))
				{
#ENDIF;				
					if(MessageReceiveSequencialNumber[PositionId]==ReadBlockIncrNumber)
					{
						return(-1);
					}
#IFNOT only_one_active_connection 1 ;
					break;					
				}
			}
#ENDIF;
			MessageReceiveSequencialNumber[PositionId]=ReadBlockIncrNumber;
			if(size>16)
			{
				read_message_block(&BlockAux,4);
				set_seconds(BlockAux);
			}
			return(0);
		}		

#IFNOT software_type RADIOBASE ;
		if(BlockAux==Message_ANSWER_START_READING_CONF && !memcmp(destination_id,remote_id,8))
		{
			beep(100,100);
			size=get_message(temp_string,1000,-1);
			auto_configure_terminal(temp_string);
		}
#ENDIF ;
		if(BlockAux==Message_ANSWER_RESET && !memcmp(destination_id,remote_id,8))
		{
			reset(0);		
		}

		if(BlockAux==Message_ANSWER_HARD_RESET && !memcmp(destination_id,remote_id,8))
		{
			reset(3+'7'*256);	
		}

		if(BlockAux==Message_ANSWER_INVALID_ID && !memcmp(destination_id,remote_id,8))
		{
			cls();
			print_string("Error:");
			new_line();
			print_string(terminal_id);
			new_line();
			print_string("already being used.");
			really_update_screen();
			delay(750000);
			write_cpu_register(31,254);			// reset_flag=1;
			reset(1);
		}


		if(BlockAux<Message_NORMAL_BLOCK && !memcmp(destination_id,remote_id,8))
		{
#IFNOT only_one_active_connection 1 ;
		
			for(PositionId=0;PositionId<MessageIdCount;PositionId++)			// Inicio de um Bloco de Dados
			{
				if(!memcmp(MessageBlockId[PositionId],destination_id,8))
				{
#ENDIF;
					goto Label2;
#IFNOT only_one_active_connection 1 ;					
				}
			}
#ENDIF;
Label2:		
			if(BlockAux<=MessageReceiveBlockNumber[PositionId])
			{
			
				ExpectedBlockNumber=MessageReceiveBlockNumber[PositionId];
				BlockAux=Message_ANSWER;
				BlockIncrNumber++;
				
				message_channel_send
				write_message_header
				write_message_block_cc(remote_id,8			wmb_sufix
				write_message_block(&SizeOfMessageAnswer,1	wmb_sufix
				write_message_block(terminal_id,8			wmb_sufix
				write_message_block(&BlockAux,2			wmb_sufix
				write_message_block(&BlockIncrNumber,2		wmb_sufix
				write_message_block(&ExpectedBlockNumber,4	wmb_sufix
				write_message_checksum
				message_channel_delay_after_send
				message_channel_off
			}
		}		
	}
	return(-1);
}
