print_large_char(char c)
{
	print_large_char2(c);
	update_screen();
}

#IF system_type rio vertical horizontal ;
print_large_char2(char c)
{
	int n;
	int size;
	char *address;
	char large_chars[41][3][4]=	{
// 0
						4,8,6,0,
						9,0,9,0,
						5,8,7,0,
// 1
//						0,4,0,0,
//						0,9,0,0,
//						8,1,8,0,
						3,2,0,0,
						0,9,0,0,
						8,1,8,0,
// 2
						4,8,6,0,
						4,8,7,0,
						1,8,8,0,
// 3
						4,8,6,0,
						0,8,11,0,
						5,8,7,0,
// 4
//						2,0,2,0,
//						1,8,9,0,
//						0,0,1,0,
						2,0,3,0,
						1,8,9,0,
						0,0,1,0,
// 5
						2,8,8,0,
						1,8,6,0,
						5,8,7,0,
// 6
						4,8,6,0,
						9,8,6,0,
						5,8,7,0,
// 7
						8,8,2,0,
						0,0,9,0,
						0,0,1,0,
// 8
						4,8,6,0,
						10,8,11,0,
						5,8,7,0,
// 9
//						4,8,6,0,
//						5,8,9,0,
//						0,0,1,0,
						4,8,6,0,
						5,8,9,0,
						5,8,7,0,
// :
						3,0,0,0,
						3,0,0,0,
						0,0,0,0,
//
						0,0,0,0,
						0,0,0,0,
						0,0,0,0,
// .
						0,0,0,0,
						0,0,0,0,
						8,0,0,0,
// ,
						0,0,0,0,
						0,0,0,0,
						2,0,0,0,
// -
						0,0,0,0,
						8,0,0,0,
						0,0,0,0,
// A
						4,8,6,0,
						9,8,9,0,
						1,0,1,0,
// B
						2,8,6,0,
						9,8,11,0,
						1,8,7,0,
// C
						4,8,6,0,
						9,0,0,0,
						5,8,7,0,
// D
						2,8,6,0,
						9,0,9,0,
						1,8,7,0,
// E
						2,8,8,0,
						9,8,0,0,
						1,8,8,0,
// F
						2,8,8,0,
						9,8,0,0,
						1,0,0,0,
// G
						4,8,8,0,
						9,0,2,0,
						5,8,1,0,
// H
						2,0,2,0,
						9,8,9,0,
						1,0,1,0,
// I
						8,2,8,0,
						0,9,0,0,
						8,1,8,0,
// J
						8,8,2,0,
						0,0,9,0,
						5,8,7,0,
// K
						2,0,2,0,
						9,2,7,0,
						1,0,1,0,
// L
						2,0,0,0,
						9,0,0,0,
						1,8,8,0,
// M
						6,3,4,0,
						9,0,9,0,
						1,0,1,0,
// N
						2,8,6,0,
						9,0,9,0,
						1,0,1,0,
// O
						4,8,6,0,
						9,0,9,0,
						5,8,7,0,
// P
						2,8,6,0,
						9,8,7,0,
						1,0,0,0,
// Q
						4,8,6,0,
						9,0,9,0,
						5,8,1,0,
// R
						2,8,6,0,
						9,2,7,0,
						1,0,1,0,
// S
						4,8,6,0,
						5,8,6,0,
						5,8,7,0,
// T
						8,2,8,0,
						0,9,0,0,
						0,1,0,0,
// U
						2,0,2,0,
						9,0,9,0,
						5,8,7,0,
// V
						2,0,2,0,
						9,0,9,0,
						0,1,0,0,
// W
						2,0,2,0,
						9,0,9,0,
						7,1,5,0,
// X
						2,0,2,0,
						0,9,0,0,
						1,0,1,0,
// Y
						2,0,2,0,
						5,2,7,0,
						0,1,0,0,
// Z
						8,8,2,0,
						2,8,1,0,
						1,8,8,0
					};
	c=c|32;
	size=2;
	switch(c)
	{
		case ':':
				c=10;
				break;
		case ' ':
				c=11;
				break;
		case '.':
				c=12;
				break;
		case ',':
				c=13;
				break;
		case '-':
				c=14;
				break;
		default:
				size=4;
				if( c >= 'a' )
				{
					c=c-'a'+15;
				}
				else
				{
					c=c-'0';
				}
				break;
	}

	if( c>=0 && c<41 )
	{

		address=read_cpu_register32(CPU_DX);
		if( ((address-print_ram)%display_width) == 0 )
		{
			new_line();
			new_line();
			address+=(2*display_width);
		}
		else
		{
			if( *(address-1)>' ' )
			{
				putch(' ');
				putch(' ');
				address+=2;
			}
		}

		address-=(2*display_width);

		while( address < print_ram )
		{
			address+=display_width;
			cursor(get_cursor()+display_width);
		}

		for(n=0;n<3;n++)
		{
			memcpy( address, large_chars[c][n], size);
			address+=display_width;
		}

		write_cpu_register32(CPU_DX,read_cpu_register32(CPU_DX)+size);
/*
		for(n=0;n<3;n++)
		{
			memcpy(read_cpu_register32(CPU_DX)+n*display_width, large_chars[c][n], size);
		}
		write_cpu_register32(CPU_DX,read_cpu_register32(CPU_DX)+size);
*/
	}

}
#ENDIF ;

#IF system_type ponto ;
define_chars(char *bitmap)
{
	int p;
	int d;
	p=bitmap;
	for(d=0;d<8;d++)
	{
		define_char(d,bitmap+d*8);
	}
}
#ENDIF ;

#IF system_type ponto ;
print_large_char2(char c)
{
	int n;
	int size;
	char bitmap[8][8]=	{
							0,0,31,31,31,31,0,0,
							31,31,31,31,31,31,0,0,
							0,0,31,31,31,31,31,31,
							0,0,0,0,31,31,31,31,
							0,0,1,7,15,15,31,31,
							31,31,15,15,7,1,0,0,
							0,0,16,28,30,30,31,31,
							31,31,30,30,28,16,0,0
						};
		
	char large_chars[40][3][3]=	{
// 0
						4,8,6,
						255,32,255,
						5,8,7,
// 1
						32,4,32,
						32,255,32,
						32,1,32,
// 2
						4,8,6,
						4,8,7,
						1,8,8,
// 3
						4,8,6,
						32,8,18,
						5,8,7,
// 4
						2,32,2,
						1,8,255,
						32,32,1,
// 5
						2,8,8,
						1,8,6,
						5,8,7,
// 6
						4,8,6,
						255,8,6,
						5,8,7,
// 7
						8,8,2,
						32,32,255,
						32,32,1,
// 8
						4,8,6,
						17,8,18,
						5,8,7,
// 9
						4,8,6,
						5,8,255,
						32,32,1,
// :
						3,32,32,
						3,32,32,
						32,32,32,
//
						32,32,32,
						32,32,32,
						32,32,32,
// .
						32,32,32,
						32,32,32,
						8,32,32,
// ,
						32,32,32,
						32,32,32,
						2,32,32,
// A
						4,8,6,
						255,8,255,
						1,32,1,
// B
						2,8,6,
						255,8,255,
						1,8,7,
// C
						4,8,6,
						255,32,32,
						5,8,7,
// D
						2,8,6,
						255,32,255,
						1,8,7,
// E
						2,8,8,
						255,8,8,
						1,8,8,
// F
						2,8,8,
						255,8,8,
						1,32,32,
// G
						4,8,8,
						255,32,2,
						5,8,1,
// H
						2,32,2,
						255,8,255,
						1,32,1,
// I
						2,32,32,
						255,32,32,
						1,32,32,
// J
						8,8,2,
						32,32,255,
						5,8,7,
// K
						2,32,2,
						255,2,7,
						1,32,1,
// L
						2,32,32,
						255,32,32,
						1,8,8,
// M
						255,2,255,
						255,32,255,
						1,32,1,
// N
						2,8,6,
						255,32,255,
						1,32,1,
// O
						4,8,6,
						255,32,255,
						5,8,7,
// P
						2,8,6,
						255,8,7,
						1,32,32,
// Q
						4,8,6,
						255,32,255,
						5,8,1,
// R
						2,8,6,
						255,2,7,
						1,32,1,
// S
						4,8,6,
						5,8,6,
						5,8,7,
// T
						8,2,8,
						32,255,32,
						32,1,32,
// U
						2,32,2,
						255,32,255,
						5,8,7,
// V
						2,32,2,
						255,32,255,
						32,1,32,
// W
						2,32,2,
						255,32,255,
						255,1,255,
// X
						2,32,2,
						32,255,32,
						1,32,1,
// Y
						2,32,2,
						5,2,7,
						32,1,32,
// Z
						8,8,2,
						2,8,1,
						1,8,8
					};

	if( p_func_define_chars != bitmap )
	{
		push_variable(get_cursor());
		define_chars(bitmap);
		cursor(pop_variable());
	}
	size=3;
	c=c|32;
	if(c=='i')
	{
		size=1;
	}
	switch(c)
	{
		case ':':
				size=1;
				c=10;
				break;
		case ' ':
				size=1;
				c=11;
				break;
		case '.':
				size=1;
				c=12;
				break;
		case ',':
				size=1;
				c=13;
				break;
		default:
				if( c > '9' )
				{
					c=c-'a'+14;
				}
				else
				{
					c=c-'0';
				}
				break;
	}
	for(n=0;n<3;n++)
	{
		memcpy(read_cpu_register32(CPU_DX)+n*display_width, large_chars[c][n], size);
	}
	write_cpu_register32(CPU_DX,read_cpu_register32(CPU_DX)+size+1);
}
#ENDIF ;

print_large_string(char *txt)
{
	while(*txt)
	{
		print_large_char2(*txt);
		txt++;
	}
	update_screen();
}

