#include "sys61.c"

//
// --------------------------------------------------------------
//

test_radio_base(char *destination_id,int radio_power,int repete)
{
	char SizeOfMessage=9;
	int Aux1;
	char channel;

	set_radio_channel(destination_id);

	if(destination_id[4]=='0')
	{
		if(repete>=0)
		{
			repete=2;
		}
	}

	if(repete>1)
	{
		wait_radio_slot(RadioSlotTime*2);
	}

	channel=(destination_id[3]-'0')&7;

	do
	{

#IFNOT software_type RADIOBASE ;
		//wait_free_slot
#ENDIF ;
		radio_channel_send

		if(value_func_pic_version>=790)
		{
			radio_configuration( (radio_config[channel]&1023) + radio_power*1024 );
		}

		write_radio_header
		write_radio_block_cc(destination_id,8)	wmb_sufix
		write_radio_block(&SizeOfMessage,1)	wmb_sufix
		write_radio_block(terminal_id,8)		wmb_sufix

		write_radio_block("v",1)			wmb_sufix						// o PC interpreta isto como "vai mas nao serve para nada"

		write_radio_checksum();
		radio_channel_delay_after_send
		radio_channel_off

		if(destination_id[7]=='R')
		{
			write_cpu_register(CPU_RADIO_SYNC_READ_SIZE,8);

			radio_channel_receive
			if(value_func_pic_version>=790)
			{
				radio_configuration( (radio_config[channel]&1023) + radio_power*1024 );	// 1024*power + 4*channel + band
															//              0-3          0-255    0-3
			}
			if(wait_radio_block(RadioSlotTime*2))
			{
				read_radio_block(remote_id,8);
				read_radio_block(&Aux1,2);
				if(Aux1==Message_ANSWER && !memcmp(destination_id,remote_id,8))
				{
					radio_channel_off
					return(1);
				}
			}
			radio_channel_off
		}
		repete--;
	}
	while(repete>0);

	return(0);
}

public int change_radio_base()
{
#IFNOT software_type RADIOBASE ;
	int n;
	char aux_work_base_id[9];
	int base,base_actual;
	char aux[3];
	int radio_power;


	if(!AutoFindBase)
	{
		set_server_status_line('?',work_base_id);
		return(0);
	}

	memcpy(aux_work_base_id,work_base_id,9);
	memcpy(aux,aux_work_base_id+3,2);
	aux[2]=0;
	base_actual=atoi(aux);
	
	base=base_actual;

	for(radio_power=0;radio_power<=3;radio_power+=1)
	{
		while(1)
		{

			base++;
			if( (base%10) > (NumberOfBases%10) )
			{
				base+=10;
				base-=(base%10);
			}
			if( (base/10) > (NumberOfBases/10) )
			{
				base=0;
			}

			if(base==base_actual)
			{
				break;
			}

			set_server_status_line('?',aux_work_base_id);
			itoa00(base,aux_work_base_id+3);
			strcpy(aux_work_base_id+6," R");
			n=test_radio_base(aux_work_base_id,radio_power,1);
			strcpy(aux_work_base_id+6," P");

			if(n)
			{
#IFNOT RadioFunctionsVersion 2 ;
#IFNOT only_one_active_connection 1 ;
				for(n=0;n<MessageIdCount;n++)
				{
					if(!memcmp(MessageBlockId[n],work_base_id,5))
					{
						memcpy(MessageBlockId[n],aux_work_base_id,5);
					}
				}
#ELSE ;
				memcpy(MessageBlockId[0],aux_work_base_id,5);		
#ENDIF;
#ENDIF;
				memcpy(work_base_id,aux_work_base_id,5);		
				set_radio_channel(work_base_id);	// muda em definitivo para o canal da base (registo nordic_configuration)
				set_server_status_line(' ',work_base_id);
#IF RadioFunctionsVersion 2 ;
				RouteSecure=0;
#ENDIF;
				return(1);
			}
		}
	}
	set_radio_channel(work_base_id);				// muda novamente para o canal da base (registo nordic_configuration)
	set_server_status_line(' ',work_base_id);
#ENDIF ;
	return(0);
}

//
// --------------------------------------------------------------
//

wait_radio_slot(int WaitingTimeParameter)
{
	int r;

	char	remote_id[8];
	char	BlockType[1];
	char	BlockFlags[1];
	char	MessageNumber[1];
	int	BlockNumber;
	int	MessageSize;
	
	int	MissingBlocks;
	int	WaitingTime;

/*
	int n;
	cursor_height(255);
	cursor_width(4);
*/

	radio_channel_receive

	WaitingTime=WaitingTimeParameter;
	do
	{
/*
		if(n>=8)
		{
			n=0;
			cursor(0);
		}
*/
		write_cpu_register(184,0);									// flush radio buffer
		write_cpu_register(CPU_RADIO_SYNC_READ_SIZE,3);

		r=wait_radio_block(WaitingTime+rnd(ONESECOND/20));

#IFNOT software_type RADIOBASE ;	

		if(read_cpu_register(CPU_RADIO_SYNCED1+3)==' ')
		{												// destination is a terminal
			if(read_cpu_register(CPU_RADIO_SYNCED1+7)==terminal_id[7])
			{											// id7 is us
				if(read_cpu_register(CPU_RADIO_SYNCED1+6)==terminal_id[6])
				{										// id6 is us so destination is us
					radio_channel_off
//beep(4,50);
					return(1);
				}
			}
		}
		else
		{												// destination is not a terminal,
			if(read_cpu_register(CPU_RADIO_SYNCED1+4)!='0')
			{											// destination is a retransmitter
				if(read_cpu_register(CPU_RADIO_SYNCED1+5)==atoi(terminal_id+6))
				{
														// final destination is us
					continue;
				}
			}
		}
#ENDIF ;

		WaitingTime=WaitingTimeParameter;
		if(r)
		{
			read_message_block(remote_id,8);
			read_message_block(BlockType,1);
			read_message_block(BlockFlags,1);
			read_message_block(MessageNumber,1);
			read_message_block(&BlockNumber,2);
			read_message_block(&MessageSize,3);
/*
			putch(*BlockType);
			putch(' ');
*/
			if((*BlockType)=='m')
			{
				if(*BlockFlags)
				{
					MissingBlocks=0;
				}
				else
				{
					MissingBlocks=(MessageSize+MaximumBlockDataSize-1)/MaximumBlockDataSize-BlockNumber-1;
				}
				//WaitingTime=(MissingBlocks*2+6)*RadioSlotTime;		// when confirmation timeout was 250ms
				//WaitingTime=(MissingBlocks*2+8)*RadioSlotTime;		// now it is 350ms
/*
				print_number(BlockNumber);
				putch('-');
				print_number(MissingBlocks);
				putch('-');
				putch(' ');
				new_line();
				really_update_screen();
				n++;
*/
			}
		}
		else
		{
/*
			print_string("                          ");
			new_line();
			really_update_screen();
			n++;
*/
			radio_channel_off
//beep(2,100);
			return(1);
		}
	}
	while(1);
}

radio_delay_after_send()
{
	if(value_func_pic_version>=750)
	{
		if(read_cpu_register(0)&8)
		{
			return(0);
		}
	}
	delay(12000000/value_func_set_radio_khz);
}


